#/function terra_system:items/pickaxes/small_stone/give
#Created by Mithey

#PARAMETERS:
#DontDisplayMessage Temp - Don't display equip message
#DontMakeSound Temp - Don't make sound on equipping
#Method Temp - What method the item should take to generate - default = give, 1 = summon, 2 = data merge
#MessageMethod Temp - What method to display message to player - default = actionbar, 1 = chat
#CustomName Temp - Makes item show name
#Invulnerable Temp - Makes item Invulnerable
#NoGravity Temp - Makes item NoGravity
#PickupDelay Temp - Makes item have a custom PickupDelay
#Age Temp - Makes item have a custom Age
#FunctionPickup Temp - If item should use the custom pickup function

function terra_system:items/on_give1

#Clear any pickaxes not meant to have
execute unless score Method Temp matches 1.. run function terra_system:items/pickaxes/clear_pickaxes

#Give item
execute unless score Method Temp matches 1.. run give @s minecraft:stone_pickaxe{DeleteOnDrop:1,CustomModelData:1,display:{Name:'{"translate":"terra.items.small_stone_pickaxe","color":"white","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.small_stone_pickaxe.lore1","color":"gray","italic":true}','{"translate":""}','[{"translate":"+2.5 ","color":"blue"},{"translate":"terra.stats.melee_damage","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"mainhand",AttributeName:"generic.attack_damage",Amount:2.5,Operation:0,Name:"generic.attack_damage",UUID:[I;-1937652395,-858370991,-1816588462,1835062348]},{Slot:"mainhand",AttributeName:"generic.attack_damage",Amount:-1.0,Operation:0,Name:"generic.attack_damage",UUID:[I;602862804,-1440792505,-1144275530,-1142615626]},{Slot:"mainhand",AttributeName:"generic.attack_speed",Amount:1024,Operation:0,Name:"generic.attack_speed",UUID:[I;-423857908,1318144547,-1353208694,-1985068394]}],HideFlags:6,CanDestroy:["gilded_blackstone","spawner","torch","wall_torch"],ItemTags:["Tool","Pickaxe","Item_PickaxeSmallStonePickaxe"]}

#Summon item
execute if score Method Temp matches 1 run summon minecraft:item ~ ~ ~ {Item:{id:"minecraft:stone_pickaxe",Count:1b,tag:{DeleteOnDrop:1,CustomModelData:1,display:{Name:'{"translate":"terra.items.small_stone_pickaxe","color":"white","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.small_stone_pickaxe.lore1","color":"gray","italic":true}','{"translate":""}','[{"translate":"+2.5 ","color":"blue"},{"translate":"terra.stats.melee_damage","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"mainhand",AttributeName:"generic.attack_damage",Amount:2.5,Operation:0,Name:"generic.attack_damage",UUID:[I;-1937652395,-858370991,-1816588462,1835062348]},{Slot:"mainhand",AttributeName:"generic.attack_damage",Amount:-1.0,Operation:0,Name:"generic.attack_damage",UUID:[I;602862804,-1440792505,-1144275530,-1142615626]},{Slot:"mainhand",AttributeName:"generic.attack_speed",Amount:1024,Operation:0,Name:"generic.attack_speed",UUID:[I;-423857908,1318144547,-1353208694,-1985068394]}],HideFlags:6,CanDestroy:["gilded_blackstone","spawner","torch","wall_torch"],ItemTags:["Tool","Pickaxe","Item_PickaxeSmallStonePickaxe"]}},Tags:["TempNewItem"]}

#Data merge item
execute if score Method Temp matches 2 run data merge entity @s {Item:{id:"minecraft:stone_pickaxe",Count:1b,tag:{DeleteOnDrop:1,CustomModelData:1,display:{Name:'{"translate":"terra.items.small_stone_pickaxe","color":"white","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.small_stone_pickaxe.lore1","color":"gray","italic":true}','{"translate":""}','[{"translate":"+2.5 ","color":"blue"},{"translate":"terra.stats.melee_damage","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"mainhand",AttributeName:"generic.attack_damage",Amount:2.5,Operation:0,Name:"generic.attack_damage",UUID:[I;-1937652395,-858370991,-1816588462,1835062348]},{Slot:"mainhand",AttributeName:"generic.attack_damage",Amount:-1.0,Operation:0,Name:"generic.attack_damage",UUID:[I;602862804,-1440792505,-1144275530,-1142615626]},{Slot:"mainhand",AttributeName:"generic.attack_speed",Amount:1024,Operation:0,Name:"generic.attack_speed",UUID:[I;-423857908,1318144547,-1353208694,-1985068394]}],HideFlags:6,CanDestroy:["gilded_blackstone","spawner","torch","wall_torch"],ItemTags:["Tool","Pickaxe","Item_PickaxeSmallStonePickaxe"]}}}
execute if score Method Temp matches 2 run tag @s add TempNewItem

#Set attributes
#execute unless score Method Temp matches 1.. run ...

#Set properties
function terra_system:items/on_give2
execute if score CustomName Temp matches 1..2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {CustomName:'{"translate":"terra.items.small_stone_pickaxe","color":"white"}',CustomNameVisible:1}
execute if score FunctionPickup Temp matches 1 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {PickupDelay:32767,Age:-32768,Tags:["Function","FunctionGlobal","FunctionGlobalItem","Item_PickaxeSmallStonePickaxe"]}
execute if score FunctionPickup Temp matches 2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {PickupDelay:32767,Age:-32768,Tags:["Function","FunctionItem","Item_PickaxeSmallStonePickaxe"]}
tag @e remove TempNewItem

#Display message
execute unless score LoopStarted Temp matches 1 unless score DontDisplayMessage Temp matches 1 run execute unless score MessageMethod Temp matches 1.. run title @s actionbar {"translate":"","extra":[{"translate":"["},{"translate":"terra.items.small_stone_pickaxe","color":"white","bold":true},{"translate":"] "},{"translate":"terra.items.equipped"}]}
execute unless score LoopStarted Temp matches 1 unless score DontDisplayMessage Temp matches 1 run execute if score MessageMethod Temp matches 1 run tellraw @s {"translate":"","extra":[{"translate":"["},{"translate":"terra.items.small_stone_pickaxe","color":"white","bold":true},{"translate":"] "},{"translate":"terra.items.equipped"}]}

#Sound
execute unless score DontMakeSound Temp matches 1 run playsound minecraft:item.armor.equip_diamond player @a

#Run function again if still need to give more
scoreboard players set LoopStarted Temp 1
scoreboard players remove Amount Temp 1
execute unless score Method Temp matches 1.. run execute if score Amount Temp matches 1.. run function terra_system:items/pickaxes/small_stone/give

function terra_system:items/on_give3








