#/function terra_system:items/weapons/melee/tier_1/stinger/give
#Created by Mithey

#PARAMETERS:
#DontDisplayMessage Temp - Don't display equip message
#DontMakeSound Temp - Don't make sound on equipping
#Method Temp - What method the item should take to generate - default = give, 1 = summon, 2 = data merge, 3 = replace item
#MessageMethod Temp - What method to display message to player - default = actionbar, 1 = chat
#CustomName Temp - Makes item show name
#Invulnerable Temp - Makes item Invulnerable
#NoGravity Temp - Makes item NoGravity
#PickupDelay Temp - Makes item have a custom PickupDelay
#Age Temp - Makes item have a custom Age
#FunctionPickup Temp - If item should use the custom pickup function
#WeaponSlot Temp - Slot weapon should be equipped to - default = 1
#Offhand Temp - If replace item should place weapon in offhand

function terra_system:items/on_give1

#Clear all current weapons
execute unless score WeaponSlot Temp matches 2.. run scoreboard players set TerraRestore IDWeaponSlot1 0
execute if score WeaponSlot Temp matches 2 run scoreboard players set TerraRestore IDWeaponSlot2 0
execute unless score Method Temp matches 1.. run function terra_system:items/weapons/clear_weapons

#Weapon ID
execute unless score Method Temp matches 1.. run execute unless score WeaponSlot Temp matches 2.. run scoreboard players set TerraRestore IDWeaponSlot1 2
execute unless score Method Temp matches 1.. run execute if score WeaponSlot Temp matches 2 run scoreboard players set TerraRestore IDWeaponSlot2 2

#Give item
execute unless score Method Temp matches 1.. run execute unless score WeaponSlot Temp matches 2.. run give @s minecraft:diamond_sword{CustomModelData:2,DeleteOnDrop:1,display:{Name:'{"translate":"terra.items.stinger","color":"green","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.uncommon","color":"green"}','{"translate":""}','[{"translate":"+7.0 ","color":"blue"},{"translate":"terra.stats.melee_damage","color":"blue"}]','[{"translate":"+20 ","color":"blue"},{"translate":"terra.stats.offense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"mainhand",AttributeName:"generic.attack_damage",Amount:6.000000,Operation:0,Name:"generic.attack_damage",UUID:[I;26249,32534,1692,814]},{Slot:"mainhand",AttributeName:"generic.attack_speed",Amount:1024.0f,Operation:0,Name:"generic.attack_speed",UUID:[I;1898,15344,11513,29179]}],HideFlags:7,Enchantments:[{id:"minecraft:sweeping",lvl:1s}],ItemTags:["Item_WeaponsMeleeStinger","WeaponMelee","WeaponSlot1"]}
execute unless score Method Temp matches 1.. run execute if score WeaponSlot Temp matches 2 run give @s minecraft:diamond_sword{CustomModelData:2,DeleteOnDrop:1,display:{Name:'{"translate":"terra.items.stinger","color":"green","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.uncommon","color":"green"}','{"translate":""}','[{"translate":"+7.0 ","color":"blue"},{"translate":"terra.stats.melee_damage","color":"blue"}]','[{"translate":"+20 ","color":"blue"},{"translate":"terra.stats.offense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"mainhand",AttributeName:"generic.attack_damage",Amount:6.000000,Operation:0,Name:"generic.attack_damage",UUID:[I;17898,17406,24154,21326]},{Slot:"mainhand",AttributeName:"generic.attack_speed",Amount:1024.0f,Operation:0,Name:"generic.attack_speed",UUID:[I;5357,25082,14492,4621]}],HideFlags:7,Enchantments:[{id:"minecraft:sweeping",lvl:1s}],ItemTags:["Item_WeaponsMeleeStinger","WeaponMelee","WeaponSlot2"]}

#Summon item
execute if score Method Temp matches 1 run summon minecraft:item ~ ~ ~ {Item:{id:"minecraft:diamond_sword",Count:1b,tag:{CustomModelData:2,DeleteOnDrop:1,display:{Name:'{"translate":"terra.items.stinger","color":"green","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.uncommon","color":"green"}','{"translate":""}','[{"translate":"+7.0 ","color":"blue"},{"translate":"terra.stats.melee_damage","color":"blue"}]','[{"translate":"+20 ","color":"blue"},{"translate":"terra.stats.offense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"mainhand",AttributeName:"generic.attack_damage",Amount:6.000000,Operation:0,Name:"generic.attack_damage",UUID:[I;28330,12247,23774,7261]},{Slot:"mainhand",AttributeName:"generic.attack_speed",Amount:1024.0f,Operation:0,Name:"generic.attack_speed",UUID:[I;13058,31909,26678,27497]}],HideFlags:7,Enchantments:[{id:"minecraft:sweeping",lvl:1s}],ItemTags:["Item_WeaponsMeleeStinger","WeaponMelee","WeaponSlot2"]}},Tags:["TempNewItem"]}

#Data merge item
execute if score Method Temp matches 2 run data merge entity @s {Item:{id:"minecraft:diamond_sword",Count:1b,tag:{CustomModelData:2,DeleteOnDrop:1,display:{Name:'{"translate":"terra.items.stinger","color":"green","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.uncommon","color":"green"}','{"translate":""}','[{"translate":"+7.0 ","color":"blue"},{"translate":"terra.stats.melee_damage","color":"blue"}]','[{"translate":"+20 ","color":"blue"},{"translate":"terra.stats.offense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"mainhand",AttributeName:"generic.attack_damage",Amount:6.000000,Operation:0,Name:"generic.attack_damage",UUID:[I;16399,18870,25762,14431]},{Slot:"mainhand",AttributeName:"generic.attack_speed",Amount:1024.0f,Operation:0,Name:"generic.attack_speed",UUID:[I;30975,8959,17986,698]}],HideFlags:7,Enchantments:[{id:"minecraft:sweeping",lvl:1s}],ItemTags:["Item_WeaponsMeleeStinger","WeaponMelee","WeaponSlot2"]}}}
execute if score Method Temp matches 2 run tag @s add TempNewItem

#Replace item
execute if score Method Temp matches 3 run execute unless score Offhand Temp matches 1 run replaceitem entity @s weapon.mainhand minecraft:diamond_sword{CustomModelData:2,DeleteOnDrop:1,display:{Name:'{"translate":"terra.items.stinger","color":"green","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.uncommon","color":"green"}','{"translate":""}','[{"translate":"+7.0 ","color":"blue"},{"translate":"terra.stats.melee_damage","color":"blue"}]','[{"translate":"+20 ","color":"blue"},{"translate":"terra.stats.offense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"mainhand",AttributeName:"generic.attack_damage",Amount:6.000000,Operation:0,Name:"generic.attack_damage",UUID:[I;12067,22208,18628,19399]},{Slot:"mainhand",AttributeName:"generic.attack_speed",Amount:1024.0f,Operation:0,Name:"generic.attack_speed",UUID:[I;8515,20584,16671,11106]}],HideFlags:7,Enchantments:[{id:"minecraft:sweeping",lvl:1s}],ItemTags:["Item_WeaponsMeleeStinger","WeaponMelee","WeaponSlot2"]}
execute if score Method Temp matches 3 run execute if score Offhand Temp matches 1 run replaceitem entity @s weapon.offhand minecraft:diamond_sword{CustomModelData:2,DeleteOnDrop:1,display:{Name:'{"translate":"terra.items.stinger","color":"green","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.uncommon","color":"green"}','{"translate":""}','[{"translate":"+7.0 ","color":"blue"},{"translate":"terra.stats.melee_damage","color":"blue"}]','[{"translate":"+20 ","color":"blue"},{"translate":"terra.stats.offense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"mainhand",AttributeName:"generic.attack_damage",Amount:6.000000,Operation:0,Name:"generic.attack_damage",UUID:[I;1333,6835,14212,8705]},{Slot:"mainhand",AttributeName:"generic.attack_speed",Amount:1024.0f,Operation:0,Name:"generic.attack_speed",UUID:[I;20397,19733,23953,19445]}],HideFlags:7,Enchantments:[{id:"minecraft:sweeping",lvl:1s}],ItemTags:["Item_WeaponsMeleeStinger","WeaponMelee","WeaponSlot2"]}

#Set attributes
execute unless score Method Temp matches 1.. run execute unless score WeaponSlot Temp matches 2.. run function terra_system:stats/reset_stats_weapon1
execute unless score Method Temp matches 1.. run execute if score WeaponSlot Temp matches 2 run function terra_system:stats/reset_stats_weapon2

execute unless score Method Temp matches 1.. run execute unless score WeaponSlot Temp matches 2.. run scoreboard players set @s HealthWeapon1 0
execute unless score Method Temp matches 1.. run execute if score WeaponSlot Temp matches 2 run scoreboard players set @s HealthWeapon2 0

execute unless score Method Temp matches 1.. run execute unless score WeaponSlot Temp matches 2.. run scoreboard players set @s SpiritWeapon1 0
execute unless score Method Temp matches 1.. run execute if score WeaponSlot Temp matches 2 run scoreboard players set @s SpiritWeapon2 0

execute unless score Method Temp matches 1.. run execute unless score WeaponSlot Temp matches 2.. run scoreboard players set @s StamWeapon1 0
execute unless score Method Temp matches 1.. run execute if score WeaponSlot Temp matches 2 run scoreboard players set @s StamWeapon2 0

execute unless score Method Temp matches 1.. run execute unless score WeaponSlot Temp matches 2.. run scoreboard players set @s OffenseWeapon1 20
execute unless score Method Temp matches 1.. run execute if score WeaponSlot Temp matches 2 run scoreboard players set @s OffenseWeapon2 20

execute unless score Method Temp matches 1.. run execute unless score WeaponSlot Temp matches 2.. run scoreboard players set @s DefenseWeapon1 0
execute unless score Method Temp matches 1.. run execute if score WeaponSlot Temp matches 2 run scoreboard players set @s DefenseWeapon2 0

execute unless score Method Temp matches 1.. run execute unless score DontDisplayMessage Temp matches 1 run function terra_system:stats/calculate_stats
execute unless score Method Temp matches 1.. run execute if score DontDisplayMessage Temp matches 1 run function terra_system:stats/calculate_stats_no_message

#Set properties
function terra_system:items/on_give2
execute if score CustomName Temp matches 1..2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {CustomName:'{"translate":"terra.items.stinger","color":"green"}',CustomNameVisible:1}
execute if score CustomName Temp matches 2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {CustomName:'{"translate":"terra.items.stinger.short_name","color":"green"}',CustomNameVisible:1}
execute if score FunctionPickup Temp matches 1 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {PickupDelay:32767,Age:-32768,Tags:["Function","FunctionGlobal","FunctionGlobalItem","Item_WeaponsMeleeStinger"]}
execute if score FunctionPickup Temp matches 2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {PickupDelay:32767,Age:-32768,Tags:["Function","FunctionItem","Item_WeaponsMeleeStinger"]}
tag @e remove TempNewItem

#Display message
execute unless score LoopStarted Temp matches 1 unless score DontDisplayMessage Temp matches 1 run execute unless score MessageMethod Temp matches 1.. run title @s actionbar {"translate":"","extra":[{"translate":"["},{"translate":"terra.items.stinger","color":"green","bold":true},{"translate":"] "},{"translate":"terra.items.equipped"}]}
execute unless score LoopStarted Temp matches 1 unless score DontDisplayMessage Temp matches 1 run execute if score MessageMethod Temp matches 1 run tellraw @s {"translate":"","extra":[{"translate":"["},{"translate":"terra.items.stinger","color":"green","bold":true},{"translate":"] "},{"translate":"terra.items.equipped"}]}

#Sound
execute unless score DontMakeSound Temp matches 1 run playsound minecraft:item.armor.equip_diamond player @a

#Run function again if still need to give more
scoreboard players set LoopStarted Temp 1
scoreboard players remove Amount Temp 1
execute unless score Method Temp matches 1.. run execute if score Amount Temp matches 1.. run function terra_system:items/weapons/melee/tier_1/stinger/give

		
#Clean up
function terra_system:items/on_give3


