#/function terra_system:main_clock
#Created by Mithey

#Check if player just logged in
scoreboard players set @a[tag=!JoinedBefore] PlayerOnline 0
execute as @a[scores={PlayerOnline=0}] at @s run function terra_system:on_join
scoreboard players set * PlayerOnline 0
scoreboard players set @a PlayerOnline 1





#Detection
execute as @e[tag=Detection,tag=!DetectionDisabledNear] at @s run execute if entity @p[distance=..35] run function terra_system:detection/check_enemy_near
execute as @e[tag=Detection] at @s run function terra_system:detection/check_enemy_rod

#Kill arrows in ground
kill @e[type=arrow,nbt={inGround:1b}]





#Check for crawling
execute as @a at @s run function terra_system:misc/check_if_crawling

#Glowing effect
execute at @a run effect give @e[tag=GlowWhenClose,distance=..3] minecraft:glowing 1 0 true

#Add gold if player has picked up some
execute as @a[nbt={Inventory:[{tag:{ItemTags:["Item_MiscGold"]}}]}] run function terra_system:gold/on_gold_pickup

#Right clicked an item
execute as @a[scores={RightClick=1..}] at @s run function terra_system:on_click_item
execute as @a[scores={RightClickHeld=1..}] at @s run function terra_system:on_right_click_held

#Damage dealt
execute as @a[scores={DamageDealt=1..}] at @s run function terra_system:on_damage_dealt
execute as @a[scores={DamageDealtAbs=1..}] at @s run function terra_system:on_damage_dealt

#Damage taken
execute as @a[scores={DamageTaken=1..}] at @s run function terra_system:on_damage_taken

#Mob kills
execute as @a[scores={MobKills=1..}] at @s run function terra_system:on_mob_kill

#Item drops
execute as @a[scores={DroppedItem=1..}] at @s run function terra_system:items/on_item_drop

#Potions
execute as @a[scores={DrankPotion=1..}] at @s run function terra_system:potions/on_drank_potion

#Health regeneration
execute as @a at @s run execute unless score @s HealthPercent matches 100 run function terra_system:health/regenerate_health_clock

#Spirit regeneration
execute as @a at @s run execute unless score @s SpiritPercent matches 100 run function terra_system:spirit/regenerate_spirit_clock

#Stamina regeneration
execute as @a at @s run execute unless score @s StamPercent matches 100 run function terra_system:stamina/regenerate_stamina

#Sneaking
execute as @a[scores={Sneaking=1..}] at @s run function terra_system:on_sneaking

#Walking
execute as @a[scores={Walking=1..}] at @s run function terra_system:on_walking

#Sprinting
execute as @a[scores={Sprinting=1..}] at @s run function terra_system:on_sprinting

#Jumping
execute as @a[scores={Jump=1..}] at @s run function terra_system:on_jump

#On trying to open locked chest/barrel
execute as @a[scores={OpenedChest=1..}] at @s run function terra_system:on_locked_chest_open
execute as @a[scores={OpenedBarrel=1..}] at @s run function terra_system:on_locked_chest_open

#Exp
execute as @a[tag=ExpToAdd] at @s run function terra_system:exp/add_exp_clock

#Second clock
scoreboard players add TerraRestore Clock 1
execute if score TerraRestore Clock matches 20.. run function terra_system:activate_second_clocks

#Food clock
execute as @a at @s run function terra_system:food/clock

#Status effects
execute as @a[tag=StatusEffect] at @s run function terra_system:status_effects/clock

#Water damage
execute as @a[gamemode=adventure] at @s run execute if block ~ ~ ~ minecraft:water run function terra_system:misc/water_damage_clock
execute as @a[gamemode=adventure] at @s run execute unless block ~ ~ ~ minecraft:water run scoreboard players set @s WaterDamage 0

#If in lava
execute as @a[gamemode=adventure] at @s run execute if block ~ ~ ~ minecraft:lava run function terra_system:on_in_lava
execute as @a[gamemode=adventure] at @s run execute if block ~ ~-1 ~ minecraft:lava run function terra_system:on_in_lava

#Player functions
execute as @a[tag=PlayerFunction] at @s run function terra_system:run_player_function

#Broke torch
execute as @a[scores={MinedTorch=1..}] at @s run function terra_system:on_mined_torch
execute as @a[scores={MinedWallTorch=1..}] at @s run function terra_system:on_mined_torch

#Keep exp at 0
xp set @a 0 points
xp set @s 0 levels

#Ensure each player still has a strider
execute unless score TerraRestore InCutscene matches 1 run execute as @a at @s run function terra_system:strider/check_player_has_strider

#Clean up extra striders/armor
execute as @e[tag=PlayerStrider] at @s run execute unless score @s StriderID matches 1.. run kill @s
execute as @e[tag=PlayerStriderArmor] at @s run execute unless score @s StriderID matches 1.. run kill @s

#Move strider to player
execute unless score TerraRestore InCutscene matches 1 run execute as @e[tag=PlayerStrider] at @s run function terra_system:strider/move_strider_to_player

#Walk on liquid
execute as @a[gamemode=adventure,scores={Sneaking=1..}] at @s run execute if block ~ ~ ~ #minecraft:liquids run execute unless entity @s[tag=Ability_Striding] run execute if score @s StatStamCurr matches 1.. run function terra_system:abilities/striding/start
execute as @a[gamemode=adventure,scores={Sneaking=1..}] at @s run execute if block ~ ~-0.2 ~ #minecraft:liquids run execute unless entity @s[tag=Ability_Striding] run execute if score @s StatStamCurr matches 1.. run function terra_system:abilities/striding/start

#Remove stamina if in liquid
execute as @a[gamemode=adventure] at @s run execute if block ~ ~ ~ #minecraft:liquids run execute unless entity @s[tag=Ability_Striding] run scoreboard players set Amount Temp 250
execute as @a[gamemode=adventure] at @s run execute if block ~ ~ ~ #minecraft:liquids run execute unless entity @s[tag=Ability_Striding] run function terra_system:stamina/remove_stamina

#Give player invisiblity and fire resistance effects
effect give @a minecraft:invisibility 3600 0 true
effect give @a minecraft:fire_resistance 3600 0 true

#Login message
scoreboard players add @a[scores={LoginMessage=..0}] LoginMessage 1
execute as @a[scores={LoginMessage=0}] at @s run function terra_system:misc/display_login_message





#Area clocks
function terra_system:areas/area_clocks






#End
function terra_system:on_game_loop_end










